﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using ThinkGeo.MapSuite.Core;
using System.Runtime.Serialization;
using System.Collections.ObjectModel;
using System.Runtime.Serialization.Json;
using System.IO;
using System.Text;

namespace QueryFeatures.Web
{
    /// <summary>
    /// Summary description for QueryService
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
    // [System.Web.Script.Services.ScriptService]
    public class QueryService : System.Web.Services.WebService
    {
        [WebMethod]
        public string GetFeatureInfo(double worldX, double worldY)
        {
            ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(HttpContext.Current.Server.MapPath("~/app_data/cntry02.shp"));
            worldLayer.Open();
            Collection<Feature> features = worldLayer.QueryTools.GetFeaturesContaining(new PointShape(worldX, worldY), ReturningColumnsType.AllColumns);
            worldLayer.Close();

            Collection<JsonFeature> jsonFeatures = new Collection<JsonFeature>();
            foreach (Feature feature in features)
            {
                JsonFeature jsonFeature = new JsonFeature();
                jsonFeature.Read(feature);
                jsonFeatures.Add(jsonFeature);
            }

            MemoryStream stream = new MemoryStream();
            DataContractJsonSerializer serializer = new DataContractJsonSerializer(typeof(Collection<JsonFeature>));
            serializer.WriteObject(stream, jsonFeatures);
            string json = Encoding.Default.GetString(stream.GetBuffer()).Trim('\0');
            stream.Close();

            return json;
        }
    }

    [DataContract]
    public class JsonFeature
    {
        private Dictionary<string, string> columnValues = new Dictionary<string, string>();

        [DataMember]
        public byte[] Wkb { get; set; }
        [DataMember]
        public Dictionary<string, string> ColumnValues { get { return columnValues; } set { columnValues = value; } }

        public void Read(Feature feature)
        {
            Wkb = feature.GetWellKnownBinary();
            foreach (string key in feature.ColumnValues.Keys)
            {
                columnValues.Add(key, feature.ColumnValues[key]);
            }
        }
    }
}
